<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * このソースファイルは CMS Designer の一部です。
	 * 詳しいライセンス規約についてはウェブサイトを参照してください。
	 *=======================================================================
	 */

	require_once( dirname(__FILE__) . "/app.php.inc" );
	require_once( dirname(__FILE__) . "/xmlutil.php.inc" );
	require_once( dirname(__FILE__) . "/user.php.inc" );
	
	class LoginForm
	{
		var $authedUser = null;
		
		var $userId = '';
		var $password = '';
		var $errorMessage = '';
		
		function LoginForm()
		{
		}
		
		
		function authUser()
		{
			// ログアウト要求があれば処理して終了する。
			if ( isset($_REQUEST['logout']) )
			{
				// ログアウト処理
				//$this->logout();
				LoginManager::Logout();
				
				// フォーム入力値の初期化
				$this->userId = '';
				$this->password = '';
				
				// 認証NG
				return false;
			}
			
			if ( LoginManager::IsAuthed() )//$this->isAuthed() )
			{
				// ログイン済みならば、何もしないで終了する。
				return true;	// 認証OK
			}
			else
			{
				// 未ログインならば・・。
				
				// ログイン要求があったか？
				if ( isset($_POST['login']))	// ログイン要求有り
				{
					// ワンタイムトークンのチェック
					if ( ReloadToken::isReload() )
					{
						$this->errorMessage = '不正な手順によるリクエストです';
						
						// 認証NG
						return false;
					}
				
					// フォームからの入力を取得する
					// ログインフォーム入力でチェックする。
					$this->userId = $_POST['param1'];
					$this->password = $_POST['param2'];
					
					// ログイン処理を実行し、結果を返却する。（成功すればtrue）
					if ( LoginManager::Login( $this->userId, $this->password ) )
					{
						// ログイン成功の場合・・
						// 認証OK
						return true;
					}
					else
					{
						// ログイン失敗の場合・・
						// エラーメッセージ
						$this->errorMessage = 'ユーザー名又はパスワードが違います';
						
						// 認証NG
						return false;
					}
				}
				else	// ログイン要求なし
				{
					// ログインフォームを表示する為に、クッキーの値を取得しておく。
					if ( isset( $_COOKIE['cmsd_param1'] ) ) { $this->userId = $_COOKIE['cmsd_param1']; }
					if ( isset( $_COOKIE['cmsd_param2'] ) ) { $this->password = $_COOKIE['cmsd_param2']; }
					
					// 認証NG
					return false;
				}
			}
			
		}
		
		/*
		function authUser2()
		{
			// ログオフ依頼があれば、ログオフ処理を行う。
			if ( $_REQUEST['auth'] == 'logoff' )
			{
				unset( $_SESSION['auth'] );
			}
			
			// ログインしている状態かをセッションでチェックする
			if ( $_SESSION['auth'] )
			{
				// ログイン済みならば、何もしないで終了する。
				return true;	// 認証OK
			}
			else
			{
				// ログイン入力があったか？
				if ( isset($_POST['login']) )
				{
					// ログインフォーム入力でチェックする。
					$formUserName = $_POST['param1'];
					$formPassword = $_POST['param2'];
					if ( $this->checkUserOK( $formUserName, $formPassword ) )
					{
						// その他の入力値も処理する。
						$saveStatus = $_POST['param3'];
						$deleteStatus = $_POST['param8'];
						$updateStatus = $_POST['param4'];
						$updateUserName = $_POST['param5'];
						$updatePassword = $_POST['param6'];
						$updatePassword2 = $_POST['param7'];
						
						$newUserName = $formUserName;
						$newPassword = $formPassword;
						
						// ログイン情報の更新
						if ( $updateStatus != '' )
						{
							// 更新ユーザー名が入力されていたら、更新する。
							if ( $updateUserName != '' )
							{
								$newUserName = $updateUserName;
							}
							
							// 更新パスワードと更新パスワード２をチェックし、一致したら更新する。
							if ( $updatePassword == $updatePassword2 )
							{
								$newPassword = $updatePassword;
							}
							else
							{
								$this->errorMessage = '変更後のパスワードが一致しません。';
								$this->dispForm();
								return false;
							}
							
							$this->userName = $newUserName;
							$this->password = crypt( $newPassword, 'cm' );
							$this->saveConfig();
						}
						
						if ( $saveStatus != '' )
						{
							$timeout = time() + 30 * 60 * 60;
							$path = '/';
							$domain = $_SERVER['SERVER_NAME'];
							// ユーザー名をクッキーに保存する。
							setcookie( 'cmsdesigner_username', $newUserName, $timeout, $path, $domain );
						}
						
						if ( $deleteStatus != '' )
						{
							$path = '/';
							$domain = $_SERVER['SERVER_NAME'];
							// ユーザー名をクッキーから削除する。
							setcookie( 'cmsdesigner_username', '', time - 3600, $path, $domain );
						}

						$_SESSION['auth'] = true;
						return true; // 認証OK
												
					}
					else
					{
						// 入力内容にNG
						$this->errorMessage = 'ユーザー名又はパスワードが違います';
						$this->inputUserName = $formUserName;
						return false; // 認証NG				
					}
					
				}
				else
				{
					// ログイン入力なしの場合
					// クッキーの値で初期値を表示する。
					$cookieUserName = $_COOKIE['cmsdesigner_username'];
					$this->inputUserName = $cookieUserName;
					
					if ( $this->userName == '' )
					{
						$this->errorMessage = 'ユーザー名が未設定です。ユーザー名、パスワードは空欄のままにして、ユーザー情報を更新してください。';
					}
					
					return false;	// 認証NG
				}
				
			}
			
		}
		
		function checkUserOK( $checkUserName, $checkPassword )
		{
			$cryptedCheckPassword = crypt( $checkPassword, 'cm' );
			
			// 設定されているユーザー名が空の場合、パスワードチェックしか行わない。
			if ( $this->userName == '' )
			{
				if ( $this->password == $cryptedCheckPassword )
				{
					return true;
				}
				else
				{
					return false;
				}
			}
			else
			{

				
				if ( strcmp( $this->userName, $checkUserName ) == 0 and 
					 strcmp( $this->password, $cryptedCheckPassword ) == 0 )
				{
					return true;
				}
				else
				{
					return false;
				}
			}
		}
		*/
		
		
		function dispForm()
		{

			// HTML生成開始	
			// DOMをを生成。
			// ルートノード'entryeditor'を生成。
			$xmlDocOutput = domxml_new_doc( '1.0' );
			$xmlOutputRoot = $xmlDocOutput->add_root( 'login' );
			
			// 入力されたユーザー名とパスワードを表示
			$xmlOutputRoot->set_attribute('userid', fileconv( $this->userId ) );
			$xmlOutputRoot->set_attribute('password', fileconv( $this->password ) );
			
			// エラーメッセージ
			if ($this->errorMessage != '' )
			{
				$xmlOutputErrorMessage = $xmlDocOutput->create_element('errormessage');
				$xmlOutputErrorMessage->set_content( fileconv( $this->errorMessage ) );
				$xmlOutputRoot->append_child( $xmlOutputErrorMessage );
			}
			
			ReloadToken::newToken();
			ReloadToken::embedToXmlDoc( $xmlDocOutput );
			
			// HTML生成終了
			// XSL変換処理
			$strFormHTML = ADXslt::process( $xmlDocOutput, dirname(__FILE__) . "/login.xsl" );
			
			/*
			$xslt = domxml_xslt_stylesheet_file( dirname(__FILE__) . "/login.xsl" );
			$result = $xslt->process( $xmlDocOutput );
			$strFormHTML = $result->dump_mem( false, 'EUC-JP' );
			*/
			
			/*
			$strFormHTML = preg_replace( "/<\?xml.*\?>\n/", "", $strFormHTML );
			*/
			
			// 文字化け不具合回避コード。2006.07.06 追加
			$strFormHTML = replaceMetaTag( $strFormHTML, 'utf-8', gCMSDInternalEncoding() );
			
			print $strFormHTML;

		}

	}

?>